<?php
/*

**************************************************************************

Plugin Name:  WP Header Notification
Plugin URI:   http://www.arefly.com/wp-header-notification/
Description:  Add a Notification bar like Google in your blog's header. 在你博客的頂部添加類似Google的通知欄
Version:      1.1.1
Author:       Arefly
Author URI:   http://www.arefly.com/

**************************************************************************

	Copyright 2014  Arefly  (email : eflyjason@gmail.com)

	This program is free software; you can redistribute it and/or modify
	it under the terms of the GNU General Public License, version 2, as 
	published by the Free Software Foundation.

	This program is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with this program; if not, write to the Free Software
	Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

**************************************************************************/

define(WP_HEADER_NOTIFICATION_PLUGIN_URL, plugin_dir_url( __FILE__ ));
define(WP_HEADER_NOTIFICATION_FULL_DIR, plugin_dir_path( __FILE__ ));

/* Plugin Localize */
function wp_header_notification_load_plugin_textdomain() {
	load_plugin_textdomain('wp-header-notification', false, dirname(plugin_basename( __FILE__ )).'/lang/');
}
add_action('plugins_loaded', 'wp_header_notification_load_plugin_textdomain');

/* Info About Arefly's Other Plugins (DO NOT CHANGE IT!) */
if(!function_exists('get_arefly_plugins_info')){
	function get_arefly_plugins_info(){
		return json_decode(json_encode(simplexml_load_file("http://file.arefly.com/arefly_plugins_info.xml")), TRUE);
	}
}
if(!function_exists('get_arefly_plugins_info_locale')){
	function get_arefly_plugins_info_locale(){
		$arefly_plugins_info = get_arefly_plugins_info();
		if(array_key_exists(get_locale(), $arefly_plugins_info["notice"])){
			$locale_code = get_locale();
		}else{
			$locale_code = "en_US";
		}
		return $locale_code;
	}
}

include_once WP_HEADER_NOTIFICATION_FULL_DIR."options.php";

/* Add Links to Plugins Management Page */
function wp_header_notification_action_links($links){
	$arefly_plugins_info = get_arefly_plugins_info();
	$locale_code = get_arefly_plugins_info_locale();
	$links[] = '<a href="'.get_admin_url(null, 'options-general.php?page=wp-header-notification-options').'">'.$arefly_plugins_info["settings"][$locale_code].'</a>';
	$links[] = '<a href="http://file.arefly.com/arefly_plugins_info.xml" target="_blank">'.$arefly_plugins_info["more_plugin_by_arefly"][$locale_code].'</a>';
	return $links;
}
add_filter('plugin_action_links_'.plugin_basename(__FILE__), 'wp_header_notification_action_links');

$notification_code = '<div id="top_notice">
	<div class="top_notice_close" onclick="pushdownclose();"> × </div>
	<div class="top_notice_text_box">
		<span class="top_notice_text">'.get_option("wp_header_notification_text").'</span>
		<div class="top_notice_button" onclick="pushdownyes();">'.get_option("wp_header_notification_button_value").'</div>
		<div class="top_notice_button" onclick="pushdownclose();">'.__("Close", "wp-header-notification").'</div>
	</div>
</div>';

if(get_option("wp_header_notification_status") == "open"){

/* Add CSS and JS code */
wp_enqueue_script('wp-header-notification', WP_HEADER_NOTIFICATION_PLUGIN_URL.'script.js');
wp_enqueue_style('wp-header-notification', WP_HEADER_NOTIFICATION_PLUGIN_URL.'style.css');

function wp_header_notification_template_include($template) {
	ob_start();
	return $template;
}
add_filter('template_include', 'wp_header_notification_template_include', 1);

/* Use a SPECIAL WAY to add code after <body> tag */
function wp_header_notification() {
	global $notification_code;
	if(!isset($_COOKIE['close_wp_header_notification'])){
		$content = ob_get_clean();
		$content = preg_replace('#<body([^>]*)>#i',"<body$1>{$notification_code}", $content);
		echo $content;
	}
}
add_filter('shutdown', 'wp_header_notification', 0);

function wp_header_notification_wp_head(){
	$wp_header_notification_renotice_time = get_option('wp_header_notification_renotice_time');
	$wp_header_notification_renotice_time = sscanf($wp_header_notification_renotice_time, "%d %d", $month, $day);
	$wp_header_notification_renotice_time = $month * 30 + $day;
	?>
<script>
var wp_header_notification_button_link = "<?php echo get_option('wp_header_notification_button_link'); ?>";
var wp_header_notification_renotice_time = <?php echo $wp_header_notification_renotice_time; ?>;
</script>
	<?php
}
add_action('wp_head', 'wp_header_notification_wp_head');
}

function get_wp_header_notification(){
	global $notification_code;
	echo $notification_code;
}